<?php
/**
 * @package Plugin: Multiple registration form and hidden fields for Community builder - Joomla! 1.5
 * @version 1.0: registration_form.php 2010-08-01
 * @author Kiran Kumar
 * @copyright (C) 2010- Kiran Kumar
 * @license GNU/GPL http://www.gnu.org/copyleft/gpl.html
**/


defined( '_JEXEC' ) or die( 'Restricted access' );
$_PLUGINS->registerFunction( 'onBeforeRegisterForm', 'onBeforeRegisterForm','multipleRegistrationHack' );
$_PLUGINS->registerFunction( 'onAfterFieldsFetch', 'onAfterFieldsFetch', 'multipleRegistrationHack' );
$_PLUGINS->registerFunction( 'onStartSaveUserRegistration', 'onStartSaveUserRegistration','multipleRegistrationHack' ); 
$_PLUGINS->registerFunction( 'onStartSaveUserRegistration', 'onStartSaveUserRegistration','multipleRegistrationHack' ); 
$_PLUGINS->registerFunction('onAfterUserRegistration','onAfterUserRegistration','multipleRegistrationHack');






/**
 * Basic tab extender. Any plugin that needs to display a tab in the user profile
 * needs to have such a class. Also, currently, even plugins that do not display tabs (e.g., auto-welcome plugin)
 * need to have such a class if they are to access plugin parameters (see $this->params statement).
 */
class multipleRegistrationHack extends cbTabHandler {
    function getregistration_formTab() {
        $this->cbTabHandler();        
    }
	

	function onAfterUserRegistration($user)
	{
		
	
            global $_CB_framework, $_CB_database, $ueConfig;
			
            $cur_form_id=$_SESSION['current_form'];
			if($cur_form_id)
			{
			$rfCurForm=$this->getHiddenDataForForm($cur_form_id);
		
			$tmp_arr = explode(",", trim($rfCurForm[1]));                               
		
			if(!is_array($tmp_arr))
			$tmp_arr=array($tmp_arr);
		
			foreach($tmp_arr as $hiddenField)
			{
		
				list($variable,$value)=explode("=",$hiddenField);
				
				$setString[]="$variable='".addslashes($value)."'";
			}
			$setString=implode(" AND ",$setString);
		$query = "UPDATE #__comprofiler SET $setString WHERE user_id=" . (int) $user->id;
		
		$database=&JFactory::getDBO();
					$database->setQuery($query);
					$database->query();
			}

	}
	
	function onBeforeRegisterForm()
	{
	 global $_CB_framework;
            
			
            $cur_form_id = $_CB_framework->getRequestVar( 'form' );
			if($cur_form_id)
			$_SESSION['current_form']=$cur_form_id;
			else
			unset($_SESSION['current_form']);
	}
	
	function getHiddenDataForForm($cur_form_id)
	{
	 $params = $this->params;
            $rfFormsFields = $params->get('rfFormsHiddenData', ''); 
			 $rfForms = explode("\n", $rfFormsFields);
            $rfCurForm = null;
            
            if(is_array($rfForms)){
                foreach ($rfForms as $number_variable => $variable) {
                    $_tmpForm = explode(":", $variable);
                    if(is_array($_tmpForm)){
                        if($_tmpForm[0] == $cur_form_id){
                            $rfCurForm = $_tmpForm;
                        }
                    }
                }
            }else{
                $_tmpForm = explode(":", $rfFormsFields);               
                if($_tmpForm[0] == $cur_form_id){
                    $rfCurForm = $_tmpForm;
                }               
            }
			
			return $rfCurForm;
			
	}
		
	
	function getFieldsForForm($cur_form_id)
	{
		
            $params = $this->params;
            $rfFormsFields = $params->get('rfFormsFields', ''); 
                        
            $rfForms = explode("\n", $rfFormsFields);
            $rfCurForm = null;
            
            if(is_array($rfForms)){
                foreach ($rfForms as $number_variable => $variable) {
                    $_tmpForm = explode(":", $variable);
                    if(is_array($_tmpForm)){
                        if($_tmpForm[0] == $cur_form_id){
                            $rfCurForm = $_tmpForm;
                        }
                    }
                }
            }else{
                $_tmpForm = explode(":", $rfFormsFields);               
                if($_tmpForm[0] == $cur_form_id){
                    $rfCurForm = $_tmpForm;
                }               
            }
			
			return $rfCurForm;
	}

	function onStartSaveUserRegistration()
	{
	{                  
	
            global $_CB_framework, $_CB_database, $ueConfig;
			
            $cur_form_id=$_SESSION['current_form'];
			
            
			$rfCurForm=$this->getFieldsForForm($cur_form_id);
            
			$except=$rfCurForm;
            
            $where              =   array();
            $ordering           =   array();
            
            if(is_array($rfCurForm)){
                $tmp_arr = explode(",", trim($rfCurForm[1]));                               
                
			
              $db=&JFactory::getDBO();
			  
			   $sql            =   'SELECT f.name as field,f.type as field_type from #__comprofiler_fields f where registration=1';
                            
                $_fields = array();
                $db->setQuery( $sql );
                $_fields=$db->loadAssocList();
				
				
				foreach($_fields as $f)
				{
					if(!in_array($f['field'],$tmp_arr))
					{
					switch($f['field_type'])
					{
						case 'emailaddress':
						$_POST[$f['field']]='notapplicable@notapplicable.com';
						break;
						
						default:
						$_POST[$f['field']]='notapplicable';
					}
					}
				}
                
				
				
                
			
            }
       }
	}
	
    function onAfterFieldsFetch($fields, $user, $reason, $tabid, $fieldIdOrName) {
        if($reason == 'register'){                  
            global $_CB_framework, $_CB_database, $ueConfig;
            
            $cur_form_id = $_CB_framework->getRequestVar( 'form' );
			if(!$cur_form_id)
			$cur_form_id=$_SESSION['current_form'];
			if($cur_form_id)
			$rfCurForm=$this->getFieldsForForm($cur_form_id);
            
            
            $where              =   array();
            $ordering           =   array();
            
            if(is_array($rfCurForm)){
                $tmp_arr = explode(",", trim($rfCurForm[1]));                               
                
                $where[]    =   "f.name in ('".implode( "','", $tmp_arr )."')";
                
                if ( $tabid ) {
                    $where[]        =   'f.tabid = ' . (int) $tabid;
					$_SESSION['tab_id']=$tabid;
                } else {
                    $where[]        =   't.enabled = 1';
                }               
//              $ordering[]     =   't.ordering_register';
//              $ordering[]     =   't.position';
//              $ordering[]     =   't.ordering';
///             $ordering[]     =   'f.ordering';
                $sql            =   'SELECT f.*';
                $sql            .=  ', t.ordering_register AS tab_ordering_register, t.position AS tab_position, t.ordering AS tab_ordering';
                $sql            .=  ' FROM #__comprofiler_fields f';
                $sql            .=  "\n INNER JOIN #__comprofiler_tabs AS t ON (f.tabid = t.tabid)";
                
                $sql            .=  "\n WHERE " . implode( ' AND ', $where );
//                          .   "\n ORDER BY " . implode( ', ', $ordering );
                            
                $_fields = array();
                $_CB_database->setQuery( $sql );
                $_fields =   $_CB_database->loadObjectList( null, 'moscomprofilerFields', array( &$_CB_database ) );
                if ( is_array( $_fields) ) {
                   for ( $i = 0, $n = count( $_fields ); $i < $n; $i++ ) {
                       $_fields[$i]->params = new cbParamsBase( $_fields[$i]->params );
                   }
                }
				
                $fields = $_fields;
            }
       }
    }    
}
?>